// ws_trim.cpp : main source file for ws_trim.exe
//
// Updated: 17th September 2005

#include "stdafx.h"

#include "resource.h"

#include "ws_trimView.h"
#include "aboutdlg.h"
#include "MainFrm.h"

CAppModule _Module;

int Run(LPTSTR /*lpstrCmdLine*/ = NULL, int nCmdShow = SW_SHOWDEFAULT)
{
	CMessageLoop theLoop;
	_Module.AddMessageLoop(&theLoop);

	CMainFrame wndMain;

	if(wndMain.CreateEx() == NULL)
	{
		ATLTRACE(_T("Main window creation failed!\n"));
		return 0;
	}

	wndMain.ShowWindow(nCmdShow);

	int nRet = theLoop.Run();

	_Module.RemoveMessageLoop();
	return nRet;
}

int WINAPI _tWinMain(HINSTANCE hinst, HINSTANCE /*hPrevInstance*/, LPTSTR lpstrCmdLine, int nCmdShow)
{
	ATLTRACE("main(): thread: 0x%08x\n", ::GetCurrentThreadId());

	try
	{
		::comstl::ole_init	coinit;

		// this resolves ATL window thunking problem when Microsoft Layer for Unicode (MSLU) is used
		::DefWindowProc(NULL, 0, 0, 0L);

		// Ensure we have the right to manage other processes
		{
			HANDLE	hToken;

			if(::OpenProcessToken(	::GetCurrentProcess()
								,	TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY
								,	&hToken))
			{
				HRESULT	hr	=	SynesisSec::Sec_EnablePrivilegeByNameA(hToken, SE_DEBUG_NAME, true);

				if(FAILED(hr))
				{
					throw winstl::windows_exception("Could not enable the \"" SE_DEBUG_NAME "\" privilege", ::GetLastError());
				}

				::CloseHandle(hToken);
			}
			else
			{
				throw winstl::windows_exception("Could not open the process token", ::GetLastError());
			}
		}

		AtlInitCommonControls(ICC_BAR_CLASSES);	// add flags to support other controls

#ifdef USE_SYNESIS_CONTROLS
		SynesisCstCtrls::InitialiseSyButtonBox(hinst);
		SynesisCstCtrls::InitialiseSyEditCell(hinst);
		SynesisCstCtrls::InitialiseSyEditBar(hinst);
		SynesisCstCtrls::InitialiseSyHexView(hinst);
		SynesisCstCtrls::InitialiseSyListBox(hinst);
		SynesisCstCtrls::InitialiseSyListView(hinst);
		SynesisCstCtrls::InitialiseSyStatusBar(hinst);
#endif /* USE_SYNESIS_CONTROLS */

		SynesisCstCtrls::InitialiseSyHyperlink(hinst);

		if(	!SynesisCstCtrls::CstCtrls_Initialise(hinst) ||
			!SynesisCstCtrls::InitialiseSyListView(hinst))
		{
			throw winstl::windows_exception("Could not initialise the Synesis Software custom controls", ::GetLastError());
		}

		::atlstl::module_scope<CAppModule/* ,  */>	ms(_Module, NULL, hinst);

		AtlAxWinInit();

		return Run(lpstrCmdLine, nCmdShow);
	}
	catch(std::exception &x)
	{
		SynesisWin::MessageBox_printf(hinst, NULL, "Unhandled error: %s", IDR_MAINFRAME, MB_ICONSTOP, x.what());

		return EXIT_FAILURE;
	}
	catch(...)
	{
		SynesisWin::MessageBox_printf(hinst, NULL, "Unhandled unknown error", IDR_MAINFRAME, MB_ICONSTOP);

		return EXIT_FAILURE;
	}
}

stlsoft::basic_static_string<TCHAR, _MAX_PATH> getModulePath(HANDLE	hProcess
														,	HMODULE	hModule)
{
	stlsoft::basic_static_string<char, _MAX_PATH>	s("", _MAX_PATH); // Construct 'full'

	DWORD cch	=	::GetModuleFileNameEx(hProcess, hModule, &s[0], _MAX_PATH);

	if(0 == cch)
	{
		throw winstl::windows_exception("Could not elicit module path", ::GetLastError());
	}
	else
	{
		s.resize(cch);
	}

	return s;
}

